﻿Option Explicit On
'Option Strict On

Public Class frm_Main
    Dim tblBindingSource As New BindingSource

    Private Sub btn_openDB_Click(sender As System.Object, e As System.EventArgs) Handles btn_openDB.Click
        Dim dbProvider As String = Nothing ' Содержит строку инициализации Database Provider (обработчик базы данных)
        Dim dbSource As String = Nothing ' Местоположение базы данных
        Dim str_queryString As String = Nothing ' переменная, содержащая SQL-запрос к БД

        dgv_Main.DataSource = Nothing
        dgv_Main.DataMember = Nothing

        ' Объявляем провайдера для работы с MS Access БД:
        dbProvider = "PROVIDER=Microsoft.Jet.OLEDB.4.0;"

        ' Указываем путь до файла БД: 
        dbSource = "Data Source = " & Application.StartupPath & "\db\Songs.mdb"

        ' Открываем базу данных:
        openDatabase(dbProvider, dbSource)

        ' подключаемся к БД и выбираем данные по SQL-запросу из БД:
        str_queryString = "SELECT * FROM Songs ORDER BY SingerName" ' выбираем все записи из БД, сортируем по имени исполнителя
        connectToDB(str_queryString)

        ' Заполняем выбранными из БД данными DataSet:
        tblName = "BazaPesen"
        fillDataSet(tblName)

        ' Закрываем соединение с базой данных:
        closeDatabase()

        ' Заполняем таблицу DataGridView данными из DataSet:
        With dgv_Main
            ' включаем автоподбор ширины столбцов DataGridView
            .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.DisplayedCells
            .Enabled = False
            .DataSource = WorkWithBase.ds
            .DataMember = tblName
            .Enabled = True
        End With

    End Sub

    Private Sub frm_Main_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        btn_deleteFromDB.Enabled = False
        Me.Text = "Пример работы с БД"

    End Sub

    Private Sub dgv_Main_CellClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Main.CellClick

        '***********************************************************************************
        ' связываем DataSet и DataGridView
        Dim findRow As DataRow = Nothing
        Dim int_index As Integer = Nothing
        Dim int_SelectedRowNumber As Integer = -1

        int_SelectedRowNumber = dgv_Main.CurrentCell.RowIndex ' получаем номер выделенной строки в DataGrid
        findRow = (dgv_Main.Rows(int_SelectedRowNumber).DataBoundItem).Row ' находим сопоставленную ей запись в DataSet
        int_SelectedRowNumber = ds.Tables(tblName).Rows.IndexOf(findRow) ' получаем номер выделенной строки в DataSet

        '***********************************************************************************

        ' выбираем информацию из DataSet, заполняем ею контролы на форме
        ' данные также можно выбирать из DataGridView
        txtbox_Compositor.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("Kompozitor").ToString
        txtbox_FileName.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("FileName").ToString
        txtbox_Poet.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("Poet").ToString
        txtbox_SingerName.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("SingerName").ToString
        txtbox_SongName.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("SongName").ToString

    End Sub

    Private Sub btn_Search_Click(sender As System.Object, e As System.EventArgs) Handles btn_Search.Click

        Dim dbProvider As String = Nothing ' Содержит строку инициализации Database Provider (обработчик базы данных)
        Dim dbSource As String = Nothing ' Местоположение базы данных
        Dim str_queryString As String = Nothing ' переменная, содержащая SQL-запрос к БД
        Dim str_searchWhat As String = Nothing ' переменная, содержащая поисковый запрос к БД

        dgv_Main.DataSource = Nothing
        dgv_Main.DataMember = Nothing

        ' Объявляем провайдера для работы с MS Access БД:
        dbProvider = "PROVIDER=Microsoft.Jet.OLEDB.4.0;"

        ' Указываем путь до файла БД: 
        dbSource = "Data Source = " & Application.StartupPath & "\db\Songs.mdb"

        ' Открываем базу данных:
        openDatabase(dbProvider, dbSource)

        ' формируем "поисковый" запрос к БД
        str_searchWhat = txtbox_Search.Text.Trim
        str_queryString = "SELECT * FROM Songs WHERE SingerName LIKE '%" + str_searchWhat + "%' " _
            & "OR SongName LIKE '%" + str_searchWhat + "%' ORDER BY SingerName"
        ' подключаемся к БД и выбираем данные по SQL-запросу из БД:
        connectToDB(str_queryString)

        ' Заполняем выбранными из БД данными DataSet:
        tblName = "BazaPesen"
        fillDataSet(tblName)

        ' Закрываем соединение с базой данных:
        closeDatabase()

        ' Заполняем данными таблицу DataGridView данными из DataSet:
        With dgv_Main
            .Enabled = False
            .DataSource = WorkWithBase.ds
            .DataMember = tblName
            .Enabled = True
            ' включаем автоподбор ширины столбцов DataGridView
            .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.DisplayedCells ' = True
        End With

    End Sub

    Private Sub btn_addNewToDB_Click(sender As System.Object, e As System.EventArgs) Handles btn_addNewToDB.Click
        frm_AddToBase.ShowDialog()

    End Sub

    Private Sub chk_deleteFromDB_Click(sender As System.Object, e As System.EventArgs) Handles chk_deleteFromDB.Click
        Application.DoEvents()
        btn_deleteFromDB.Enabled = CBool(chk_deleteFromDB.CheckState)
    End Sub

    Private Sub btn_deleteFromDB_Click(sender As System.Object, e As System.EventArgs) Handles btn_deleteFromDB.Click
        btn_deleteFromDB.Enabled = False
        chk_deleteFromDB.Checked = False

        '***********************************************************************************
        ' связываем DataSet и DataGridView
        Dim findRow As DataRow = Nothing
        Dim int_index As Integer = Nothing
        Dim int_SelectedRowNumber As Integer = -1

        int_SelectedRowNumber = dgv_Main.CurrentCell.RowIndex ' получаем номер выделенной строки в DataGrid
        findRow = (dgv_Main.Rows(int_SelectedRowNumber).DataBoundItem).Row ' находим сопоставленную ей запись в DataSet
        int_SelectedRowNumber = ds.Tables(tblName).Rows.IndexOf(findRow) ' получаем номер выделенной строки в DataSet

        '***********************************************************************************

        ' вызываем процедуру удаления записи из БД
        deleteFromDatabase(int_SelectedRowNumber, tblName)

    End Sub

    Private Sub dgv_Main_CellContentClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs)

    End Sub

    Private Sub btn_Filter_Click(sender As System.Object, e As System.EventArgs) Handles btn_Filter.Click

        Dim str_filterWhat As String = txtbox_Filter.Text.Trim ' выбираем из текстбокса строку, по которой будем фильтровать ДатаГрид

        tblBindingSource.DataSource = ds.Tables(tblName) ' помещаем в источник таблицу, которую будем фильтровать
        ' смотри "Dim tblBindingSource As New BindingSource" поиском по проекту

        tblBindingSource.Filter = "FileName LIKE '%" + str_filterWhat + "%'" ' применяем фильтр 

        dgv_Main.DataSource = Nothing
        dgv_Main.DataSource = tblBindingSource.DataSource ' указываем ДатаГрид использовать фильтрованные данные для отображения

    End Sub

    Private Sub btn_clearFilter_Click(sender As System.Object, e As System.EventArgs) Handles btn_clearFilter.Click
        tblBindingSource.Filter = Nothing ' можно так сбросить фильтр
        tblBindingSource.RemoveFilter() ' а можно так

    End Sub

End Class
